<?php
class condventaActions extends wtActions
{
    public function executeIndex()
    {
    }

    public function executeList()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
    }

    public function executeGrid()
    {
        $block = $this->getRequestParameter( 'block' );
        $page  = $this->getRequestParameter( 'page' );

        //*set_header_utf8();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $o_GridAction = new GridAction();
        $o_GridAction->setClassFind( new VTA_FormaPagoFN() );

        //$o_GridAction->addAssignFilter( "IdCompania" );
        //$o_GridAction->addAssignFilter( "IdPersona" );
        //$o_GridAction->addAssignFilter( "IdCompania" );
        $o_GridAction->addAssignFilter( "DescripcionLocal" );
        //$o_GridAction->addAssignFilter( "Codigo" );
        //$o_GridAction->addAssignFilter( "ClaseNombre" );
        $o_GridAction->addAssignFilter( "Estado" );
        //$o_GridAction->addConditionFilter( "Descripcion", GSS_ImpuestoFN::Descripcion, "LIKE", "%%s%" );

        //$o_GridAction->addOrder( "Descripcion", GSS_ImpuestoFN::Descripcion );
        //$o_GridAction->addOrder( "Codigo",      GSS_ImpuestoFN::Codigo );

        $o_GridAction->addOrderDefault( VTA_FormaPagoFN::IdFormaPago, true );

        $o_GridAction->addRowsToShow( "IdFormaPago", "DescripcionLocal", "Dias", "Estado", "EstadoDesc"  );

        $o_GridAction->setNumberRecordsShow( 100 );

        $o_GridAction->initialize();
        ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        $a_ResultJson['page']    = $o_GridAction->getPage();
        $a_ResultJson['total']   = $o_GridAction->getTotalPage();
        $a_ResultJson['records'] = $o_GridAction->getTotalRecords();
        $a_ResultJson['rows']    = $o_GridAction->getResultArray();
        //pr( $a_ResultJson );
        echo json_encode( $a_ResultJson );

        return ViewResponse::NONE;
    }

    public function executeAddedit()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();

        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );

        $this->s_Titulo = "Nueva Condicion de Venta";

        $this->o_DefaultBN = new VTA_FormaPagoBN();

        if( $this->s_TipoProc == "upd" )
        {
            $this->s_Titulo = "Editar Condicion de Venta";

            $o_DefaultFN = new VTA_FormaPagoFN();
            $this->o_DefaultBN = $o_DefaultFN->selectByPK( $this->i_Id );
        }
    }

    public function executeSaveAddEdit()
    {
        $i_Id          = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc    = $this->getRequestParameter( 's_TipoProc' );
        $TypeSub       = $this->getRequestParameter( 'TypeSub' );
        $Estado        = $this->getRequestParameter( 'Estado' );
        $s_Descripcion = $this->getRequestParameter( 'Descripcion' );
        $i_CantDias    = intval( $this->getRequestParameter( 'CantDias' ) );

        //$IdCompania = ( int ) $this->getRequestParameter( 'IdCompania' );
        $IdCompania  = myUser::getUser()->getIdCompania();
        //$IdSucursal = ( int ) $this->getRequestParameter( 'IdSucursal' );
        $IdSucursal  = myUser::getUser()->getIdSucursal();

        //pr($_REQUEST);

        try

        {
            $o_DefaultDP = new VTA_FormaPagoDP();

            $o_DefaultDP->setEstado( $Estado );
            $o_DefaultDP->setDescripcionLocal( $s_Descripcion );
            $o_DefaultDP->setDias( $i_CantDias );
            $o_DefaultDP->setCodigo( "CON" );
            $o_DefaultDP->setContadoFlag( "S" );
            if( $i_CantDias > 0 )
            {
                $o_DefaultDP->setCodigo( "CRE" );
                $o_DefaultDP->setContadoFlag( "N" );
            }

            if( $s_TipoProc == "nvo" )
            {
                //NUEVO
                $i_Id = VTA_FormaPagoDP::recuperarId();
                $i_Id = str_pad( $i_Id, 3, "0", STR_PAD_LEFT );
                $o_DefaultDP->setIdFormaPago( $i_Id );
                $o_DefaultDP->setFechaCreacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioCreacion( myUser::getUser()->getUserId() );
                $o_DefaultDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                //$o_DefaultDP->setIdCompania( $IdCompania );
                $o_DefaultDP->save();
            }
            else
            {
                //UPDATE
                $o_DefaultDP->setIdFormaPago( $i_Id );
                $o_DefaultDP->setFechaModificacion( date( "Y-m-d H:i:s" ) );
                $o_DefaultDP->setUsuarioModificacion( myUser::getUser()->getUserId() );
                $o_DefaultDP->update();
            }

            $a_Rs['error']    = false;
            $a_Rs['id']       = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']         = true;
            $a_Rs['mensaje_error'] = $o_Exception->getMessage();
        }

        echo json_encode( $a_Rs );

        return ViewResponse::NONE;
    }

    public function executeViewdel()
    {
        LayoutTemplate::getInstance()->setUseBootstrap();
        $this->block      = $this->getRequestParameter( 'block' );
        $this->i_Id       = $this->getRequestParameter( 'i_Id' );
        $this->s_TipoProc = $this->getRequestParameter( 's_TipoProc' );

        $o_DefaultFN = new VTA_FormaPagoFN();
        $this->o_DefaultBN = $o_DefaultFN->selectByPK( $this->i_Id );
    }

    public function executeDeleteRow()
    {
        $block      = $this->getRequestParameter( 'block' );
        $i_Id       = $this->getRequestParameter( 'i_Id' );
        $s_TipoProc = $this->getRequestParameter( 's_TipoProc' );
        try
        {
            $o_DefaultDP = new GSS_ImpuestoDP();
            $o_DefaultDP->setIdImpuesto( ( int ) $i_Id );
            //$o_DefaultDP->delete();

            $a_Rs['error']   = false;
            $a_Rs['id']      = $i_Id;
        }
        catch ( Exception $o_Exception )
        {
            $a_Rs['error']   = true;
            $a_Rs['mensaje_error_ex'] = $o_Exception->getMessage();
            $a_Rs['mensaje_error'] = "No se pudo eliminar el registro.";
        }
        echo json_encode( $a_Rs );
        return ViewResponse::NONE;
    }
}